de.esprit.common.gui

## Class ZDialog

- java.lang.Object
- - java.awt.Component
  - - java.awt.Container
    - - java.awt.Window
      - - java.awt.Dialog
        - - javax.swing.JDialog
          - - de.esprit.common.gui.ZDialog

- All Implemented Interfaces:
    BorderLayoutConstants, Closeable, ToolWindow, Dumpable, java.awt.image.ImageObserver, java.awt.MenuContainer, java.io.Serializable, javax.accessibility.Accessible, javax.swing.RootPaneContainer, javax.swing.WindowConstants
  Direct Known Subclasses:
    ToolDialog

      public abstract class ZDialog
      extends javax.swing.JDialog
      implements ToolWindow, BorderLayoutConstants

  This is the base class for all GUI dialogs. It automatically manages a current Dialog (global in the Gui class) for automatically hooking up error dialogs. Furthermore it provides default Apply-/Close-/Cancel-buttons depending on which ones are required - just override the according configuration methods to return true.
  Author:
    Rainer Buesch
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class javax.swing.JDialog

      `javax.swing.JDialog.AccessibleJDialog`

    - ### Nested classes/interfaces inherited from class java.awt.Dialog

      `java.awt.Dialog.AccessibleAWTDialog, java.awt.Dialog.ModalExclusionType, java.awt.Dialog.ModalityType`

    - ### Nested classes/interfaces inherited from class java.awt.Window

      `java.awt.Window.AccessibleAWTWindow, java.awt.Window.Type`

    - ### Nested classes/interfaces inherited from class java.awt.Container

      `java.awt.Container.AccessibleAWTContainer`

    - ### Nested classes/interfaces inherited from class java.awt.Component

      `java.awt.Component.AccessibleAWTComponent, java.awt.Component.BaselineResizeBehavior, java.awt.Component.BltBufferStrategy, java.awt.Component.FlipBufferStrategy`

  - ### Field Summary

    - ### Fields inherited from class javax.swing.JDialog

      `accessibleContext, rootPane, rootPaneCheckingEnabled`

    - ### Fields inherited from class java.awt.Dialog

      `DEFAULT_MODALITY_TYPE`

    - ### Fields inherited from class java.awt.Component

      `BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

    - ### Fields inherited from interface de.esprit.common.gui.comp.BorderLayoutConstants

      `CENTER, EAST, NORTH, SOUTH, WEST`

    - ### Fields inherited from interface javax.swing.WindowConstants

      `DISPOSE_ON_CLOSE, DO_NOTHING_ON_CLOSE, EXIT_ON_CLOSE, HIDE_ON_CLOSE`

    - ### Fields inherited from interface java.awt.image.ImageObserver

      `ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ZDialog(java.awt.Window parent, NlsKey nls)` Hooks this dialog onto another dialog.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()` Just makes the dialog invisible.
    `protected void` | `closeByIcon()` Is called when closing the window by the close-icon
    `protected ToolWindowAdapter` | `createWindowAdapter()`
    `void` | `dispose()`
    `int` | `getMinimumHeight()`
    `int` | `getMinimumWidth()`
    `protected ToolWindowAdapter` | `getWindowAdapter()`
    `protected boolean` | `isDisposeOnClose()` Tells whether this dialog should release its native resources such that the garbage collector can free its memory.
    `protected boolean` | `isErrorAttachable()` This method defines whether error dialogs may attach to this dialog.
    `boolean` | `isLocated()`
    `boolean` | `isPacked()`
    `void` | `pack()` Overridden to store the minimum size for size control
    `void` | `popup()` Pops up the frame to become visible
    `void` | `registerSubDialog(javax.swing.JDialog subDialog)` Registers this dialog as a sub-dialog of its parent `ZDialog`.
    `void` | `repack()` Runs a pack() as if it was the initial pack
    `void` | `setLocation(int x, int y)`
    `void` | `setLocationRelativeTo(java.awt.Component c)`
    `void` | `setLocationRelativeTo(java.awt.Component comp, WindowAlignment alignment)`
    `void` | `setLocationToCenter()` Places the dialog in the center of the screen.
    `void` | `setTitle(NlsKey nls, java.lang.Object... args)` Overridden to use translation
    `void` | `setVisible(boolean isVisible)` Overridden to ensure that the dialog is being packed before it becomes visible
    `void` | `shiftLocation(int deltaX, int deltaY)` Moves the frame on the screen by the given amount.
    `java.lang.String` | `toDumpString()` Returns a multi-line String that shows the values (name=value) of all important state variables of this object.
    `DumpString` | `toDumpString(DumpString s)` This method allows subclasses to add values to the existing DumpString of the superclass.
    `java.lang.String` | `toString()` Returns a single line String that shows the values of the most important state variables of this object.
    `ToString` | `toString(ToString s)` This method allows subclasses to add values to the existing ToString of the superclass.

    - ### Methods inherited from class javax.swing.JDialog

      `addImpl, createRootPane, dialogInit, getAccessibleContext, getContentPane, getDefaultCloseOperation, getGlassPane, getGraphics, getJMenuBar, getLayeredPane, getRootPane, getTransferHandler, isDefaultLookAndFeelDecorated, isRootPaneCheckingEnabled, paramString, processWindowEvent, remove, repaint, setContentPane, setDefaultCloseOperation, setDefaultLookAndFeelDecorated, setGlassPane, setJMenuBar, setLayeredPane, setLayout, setRootPane, setRootPaneCheckingEnabled, setTransferHandler, update`

    - ### Methods inherited from class java.awt.Dialog

      `addNotify, getModalityType, getTitle, hide, isModal, isResizable, isUndecorated, setBackground, setModal, setModalityType, setOpacity, setResizable, setShape, setTitle, setUndecorated, show, toBack`

    - ### Methods inherited from class java.awt.Window

      `addPropertyChangeListener, addPropertyChangeListener, addWindowFocusListener, addWindowListener, addWindowStateListener, applyResourceBundle, applyResourceBundle, createBufferStrategy, createBufferStrategy, getBackground, getBufferStrategy, getFocusableWindowState, getFocusCycleRootAncestor, getFocusOwner, getFocusTraversalKeys, getIconImages, getInputContext, getListeners, getLocale, getModalExclusionType, getMostRecentFocusOwner, getOpacity, getOwnedWindows, getOwner, getOwnerlessWindows, getShape, getToolkit, getType, getWarningString, getWindowFocusListeners, getWindowListeners, getWindows, getWindowStateListeners, isActive, isAlwaysOnTop, isAlwaysOnTopSupported, isAutoRequestFocus, isFocusableWindow, isFocusCycleRoot, isFocused, isLocationByPlatform, isOpaque, isShowing, isValidateRoot, paint, postEvent, processEvent, processWindowFocusEvent, processWindowStateEvent, removeNotify, removeWindowFocusListener, removeWindowListener, removeWindowStateListener, reshape, setAlwaysOnTop, setAutoRequestFocus, setBounds, setBounds, setCursor, setFocusableWindowState, setFocusCycleRoot, setIconImage, setIconImages, setLocation, setLocationByPlatform, setMinimumSize, setModalExclusionType, setSize, setSize, setType, toFront`

    - ### Methods inherited from class java.awt.Container

      `add, add, add, add, add, addContainerListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getAlignmentX, getAlignmentY, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalPolicy, getInsets, getLayout, getMaximumSize, getMinimumSize, getMousePosition, getPreferredSize, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, print, printComponents, processContainerEvent, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusTraversalKeys, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setFont, transferFocusDownCycle, validate, validateTree`

    - ### Methods inherited from class java.awt.Component

      `action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, contains, createImage, createImage, createVolatileImage, createVolatileImage, disable, disableEvents, dispatchEvent, enable, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBaseline, getBaselineResizeBehavior, getBounds, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getFontMetrics, getForeground, getGraphicsConfiguration, getHeight, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocation, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPeer, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getSize, getTreeLock, getWidth, getX, getY, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isDoubleBuffered, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, prepareImage, prepareImage, printAll, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processKeyEvent, processMouseEvent, processMouseMotionEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resize, resize, revalidate, setComponentOrientation, setDropTarget, setEnabled, setFocusable, setFocusTraversalKeysEnabled, setForeground, setIgnoreRepaint, setLocale, setMaximumSize, setName, setPreferredSize, show, size, transferFocus, transferFocusBackward, transferFocusUpCycle`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface de.esprit.common.gui.ToolWindow

      `getLocation, getSize, getTitle, getToolkit, setMinimumSize, setPreferredSize`

- - ### Constructor Detail

    - #### ZDialog

          public ZDialog(java.awt.Window parent,
                 NlsKey nls)

      Hooks this dialog onto another dialog.

  - ### Method Detail

    - #### createWindowAdapter

          protected ToolWindowAdapter createWindowAdapter()

    - #### setLocation

          public final void setLocation(int x,
                         int y)

      Specified by:
        `setLocation` in interface `ToolWindow`
      Overrides:
        `setLocation` in class `java.awt.Window`

    - #### isLocated

          public final boolean isLocated()

    - #### getWindowAdapter

          protected ToolWindowAdapter getWindowAdapter()

    - #### pack

          public void pack()

      Overridden to store the minimum size for size control
      Specified by:
        `pack` in interface `ToolWindow`
      Overrides:
        `pack` in class `java.awt.Window`

    - #### isPacked

          public final boolean isPacked()

      Specified by:
        `isPacked` in interface `ToolWindow`

    - #### repack

          public final void repack()

      Runs a pack() as if it was the initial pack

    - #### getMinimumHeight

          public int getMinimumHeight()

      Specified by:
        `getMinimumHeight` in interface `ToolWindow`

    - #### getMinimumWidth

          public int getMinimumWidth()

      Specified by:
        `getMinimumWidth` in interface `ToolWindow`

    - #### popup

          public void popup()

      Description copied from interface: `ToolWindow`
      Pops up the frame to become visible
      Specified by:
        `popup` in interface `ToolWindow`

    - #### setVisible

          public final void setVisible(boolean isVisible)

      Overridden to ensure that the dialog is being packed before it becomes visible
      Overrides:
        `setVisible` in class `java.awt.Dialog`

    - #### closeByIcon

          protected void closeByIcon()

      Is called when closing the window by the close-icon

    - #### setTitle

          public final void setTitle(NlsKey nls,
                      java.lang.Object... args)

      Overridden to use translation

    - #### shiftLocation

          public final void shiftLocation(int deltaX,
                           int deltaY)

      Moves the frame on the screen by the given amount. Borders are checked - so the frame will not move out of the screen area.
      Specified by:
        `shiftLocation` in interface `ToolWindow`

    - #### setLocationRelativeTo

          public final void setLocationRelativeTo(java.awt.Component comp,
                                   WindowAlignment alignment)

    - #### setLocationToCenter

          public final void setLocationToCenter()

      Places the dialog in the center of the screen.

    - #### setLocationRelativeTo

          public final void setLocationRelativeTo(java.awt.Component c)

      Specified by:
        `setLocationRelativeTo` in interface `ToolWindow`
      Overrides:
        `setLocationRelativeTo` in class `java.awt.Window`

    - #### close

          public void close()

      Just makes the dialog invisible.
      Specified by:
        `close` in interface `Closeable`

    - #### dispose

          public final void dispose()

      Overrides:
        `dispose` in class `java.awt.Window`

    - #### registerSubDialog

          public final void registerSubDialog(javax.swing.JDialog subDialog)

      Registers this dialog as a sub-dialog of its parent `ZDialog`. If the parent is disposed, then this dialog is being disposed as well.

    - #### isDisposeOnClose

          protected boolean isDisposeOnClose()

      Tells whether this dialog should release its native resources such that the garbage collector can free its memory. If the dialog is not being cached then this method should be overridden to return true. Note that all sub-dialogs of this dialog will be disposed as well.
      Returns:
        true if dialog is not cached. Default is false.

    - #### isErrorAttachable

          protected boolean isErrorAttachable()

      This method defines whether error dialogs may attach to this dialog.
      Returns:
        true by default.

    - #### toDumpString

          public java.lang.String toDumpString()

      Description copied from interface: `Dumpable`
      Returns a multi-line String that shows the values (name=value) of all important state variables of this object.
      Specified by:
        `toDumpString` in interface `Dumpable`

    - #### toDumpString

          public DumpString toDumpString(DumpString s)

      Description copied from interface: `Dumpable`
      This method allows subclasses to add values to the existing DumpString of the superclass. Usually subclasses only need to override this method.
      Specified by:
        `toDumpString` in interface `Dumpable`

    - #### toString

          public java.lang.String toString()

      Description copied from interface: `Dumpable`
      Returns a single line String that shows the values of the most important state variables of this object. This is intentionally the same toString() method which is already provided by Object per se.
      Specified by:
        `toString` in interface `Dumpable`
      Overrides:
        `toString` in class `java.awt.Component`

    - #### toString

          public ToString toString(ToString s)

      Description copied from interface: `Dumpable`
      This method allows subclasses to add values to the existing ToString of the superclass. Usually subclasses only need to override this method.
      Specified by:
        `toString` in interface `Dumpable`

Copyright © 2014 EsprIT-Systems. All Rights Reserved.